diff -r 5e0d53cac617 trytond/modules/purchase/purchase.py
--- a/trytond/modules/purchase/purchase.py	Mon Sep 10 15:28:28 2012 +0200
+++ b/trytond/modules/purchase/purchase.py	Mon Sep 24 20:36:42 2012 +0200
@@ -973,345 +865,261 @@
                     'an "account expense" default property!',
             })
 
-    def init(self, module_name):
-        super(PurchaseLine, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(PurchaseLine, cls).__register__(module_name)
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
         # Migration from 1.0 comment change into note
         if table.column_exist('comment'):
-            cursor.execute('UPDATE "' + self._table + '" ' \
+            cursor.execute('UPDATE "' + cls._table + '" ' \
                     'SET note = comment')
             table.drop_column('comment', exception=True)
 
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return 'line'
 
-    def get_move_done(self, ids, name):
-        uom_obj = Pool().get('product.uom')
-        res = {}
-        for line in self.browse(ids):
-            val = True
-            if not line.product:
-                res[line.id] = True
-                continue
-            if line.product.type == 'service':
-                res[line.id] = True
-                continue
-            skip_ids = set(x.id for x in line.moves_recreated + \
-                                line.moves_ignored)
-            quantity = line.quantity
-            for move in line.moves:
-                if move.state != 'done' \
-                        and move.id not in skip_ids:
-                    val = False
-                    break
-                quantity -= uom_obj.compute_qty(move.uom, move.quantity,
-                        line.unit)
-            if val:
-                if quantity > 0.0:
-                    val = False
-            res[line.id] = val
-        return res
+    def get_move_done(self, name):
+        Uom = Pool().get('product.uom')
+        done = True
+        if not self.product:
+            return True
+        if self.product.type == 'service':
+            return True
+        skip_ids = set(x.id for x in self.moves_recreated
+            + self.moves_ignored)
+        quantity = self.quantity
+        for move in self.moves:
+            if move.state != 'done' \
+                    and move.id not in skip_ids:
+                done = False
+                break
+            quantity -= Uom.compute_qty(move.uom, move.quantity, self.unit)
+        if done:
+            if quantity > 0.0:
+                done = False
+        return done
 
-    def get_move_exception(self, ids, name):
-        res = {}
-        for line in self.browse(ids):
-            val = False
-            skip_ids = set(x.id for x in line.moves_ignored + \
-                               line.moves_recreated)
-            for move in line.moves:
-                if move.state == 'cancel' \
-                        and move.id not in skip_ids:
-                    val = True
-                    break
-            res[line.id] = val
-        return res
+    def get_move_exception(self, name):
+        skip_ids = set(x.id for x in self.moves_ignored
+            + self.moves_recreated)
+        for move in self.moves:
+            if move.state == 'cancel' \
+                    and move.id not in skip_ids:
+                return True
+        return False
 
-    def on_change_with_unit_digits(self, vals):
-        uom_obj = Pool().get('product.uom')
-        if vals.get('unit'):
-            uom = uom_obj.browse(vals['unit'])
-            return uom.digits
+    def on_change_with_unit_digits(self, name=None):
+        if self.unit:
+            return self.unit.digits
         return 2
 
-    def get_unit_digits(self, ids, name):
-        res = {}
-        for line in self.browse(ids):
-            if line.unit:
-                res[line.id] = line.unit.digits
-            else:
-                res[line.id] = 2
-        return res
-
-    def _get_tax_rule_pattern(self, party, vals):
+    def _get_tax_rule_pattern(self):
         '''
         Get tax rule pattern
+        '''
+        return {}
 
-        :param party: the BrowseRecord of the party
-        :param vals: a dictionary with value from on_change
-        :return: a dictionary to use as pattern for tax rule
-        '''
-        res = {}
-        return res
+    def _get_context_purchase_price(self):
+        context = {}
+        if self.purchase:
+            if self.purchase.currency:
+                context['currency'] = self.purchase.currency.id
+            if self.purchase.party:
+                context['supplier'] = self.purchase.party.id
+            if self.purchase.purchase_date:
+                context['purchase_date'] = self.purchase.purchase_date
+        if self.unit:
+            context['uom'] = self.unit.id
+        else:
+            self.product.purchase_uom.id
+        return context
 
-    def on_change_product(self, vals):
-        pool = Pool()
-        party_obj = pool.get('party.party')
-        product_obj = pool.get('product.product')
-        tax_rule_obj = pool.get('account.tax.rule')
+    def on_change_product(self):
+        Product = Pool().get('product.product')
 
-        if not vals.get('product'):
+        if not self.product:
             return {}
         res = {}
 
         context = {}
         party = None
-        if vals.get('_parent_purchase.party'):
-            party = party_obj.browse(vals['_parent_purchase.party'])
+        if self.purchase and self.purchase.party:
+            party = self.purchase.party
             if party.lang:
                 context['language'] = party.lang.code
 
-        product = product_obj.browse(vals['product'])
-
-        context2 = {}
-        if vals.get('_parent_purchase.currency'):
-            context2['currency'] = vals['_parent_purchase.currency']
-        if vals.get('_parent_purchase.party'):
-            context2['supplier'] = vals['_parent_purchase.party']
-        if vals.get('unit'):
-            context2['uom'] = vals['unit']
-        else:
-            context2['uom'] = product.purchase_uom.id
-        if vals.get('_parent_purchase.purchase_date'):
-            context2['purchase_date'] = vals['_parent_purchase.purchase_date']
-        with Transaction().set_context(context2):
-            res['unit_price'] = product_obj.get_purchase_price([product.id],
-                    vals.get('quantity') or 0)[product.id]
+        with Transaction().set_context(self._get_context_purchase_price()):
+            res['unit_price'] = Product.get_purchase_price([self.product],
+                self.quantity or 0)[self.product.id]
             if res['unit_price']:
                 res['unit_price'] = res['unit_price'].quantize(
-                    Decimal(1) / 10 ** self.unit_price.digits[1])
+                    Decimal(1) / 10 ** self.__class__.unit_price.digits[1])
         res['taxes'] = []
-        pattern = self._get_tax_rule_pattern(party, vals)
-        for tax in product.supplier_taxes_used:
+        pattern = self._get_tax_rule_pattern()
+        for tax in self.product.supplier_taxes_used:
             if party and party.supplier_tax_rule:
-                tax_ids = tax_rule_obj.apply(party.supplier_tax_rule, tax,
-                        pattern)
+                tax_ids = party.supplier_tax_rule.apply(tax, pattern)
                 if tax_ids:
                     res['taxes'].extend(tax_ids)
                 continue
             res['taxes'].append(tax.id)
         if party and party.supplier_tax_rule:
-            tax_ids = tax_rule_obj.apply(party.supplier_tax_rule, None,
-                    pattern)
+            tax_ids = party.supplier_tax_rule.apply(None, pattern)
             if tax_ids:
                 res['taxes'].extend(tax_ids)
 
-        if not vals.get('description'):
+        if not self.description:
             with Transaction().set_context(context):
-                res['description'] = product_obj.browse(product.id).rec_name
+                res['description'] = Product(self.product.id).rec_name
 
-        category = product.purchase_uom.category
-        if not vals.get('unit') \
-                or vals.get('unit') not in [x.id for x in category.uoms]:
-            res['unit'] = product.purchase_uom.id
-            res['unit.rec_name'] = product.purchase_uom.rec_name
-            res['unit_digits'] = product.purchase_uom.digits
+        category = self.product.purchase_uom.category
+        if not self.unit or self.unit not in category.uoms:
+            res['unit'] = self.product.purchase_uom.id
+            res['unit.rec_name'] = self.product.purchase_uom.rec_name
+            res['unit_digits'] = self.product.purchase_uom.digits
 
-        vals = vals.copy()
-        vals['unit_price'] = res['unit_price']
-        vals['type'] = 'line'
-        res['amount'] = self.on_change_with_amount(vals)
+        self.unit_price = res['unit_price']
+        self.type = 'line'
+        res['amount'] = self.on_change_with_amount()
         return res
 
-    def on_change_with_product_uom_category(self, values):
-        pool = Pool()
-        product_obj = pool.get('product.product')
-        if values.get('product'):
-            product = product_obj.browse(values['product'])
-            return product.default_uom_category.id
+    def on_change_with_product_uom_category(self, name=None):
+        if self.product:
+            return self.product.default_uom_category.id
 
-    def get_product_uom_category(self, ids, name):
-        categories = {}
-        for line in self.browse(ids):
-            if line.product:
-                categories[line.id] = line.product.default_uom_category.id
-            else:
-                categories[line.id] = None
-        return categories
+    def on_change_quantity(self):
+        Product = Pool().get('product.product')
 
-    def on_change_quantity(self, vals):
-        product_obj = Pool().get('product.product')
-
-        if not vals.get('product'):
+        if not self.product:
             return {}
         res = {}
 
-        context = {}
-        if vals.get('_parent_purchase.currency'):
-            context['currency'] = vals['_parent_purchase.currency']
-        if vals.get('_parent_purchase.party'):
-            context['supplier'] = vals['_parent_purchase.party']
-        if vals.get('_parent_purchase.purchase_date'):
-            context['purchase_date'] = vals['_parent_purchase.purchase_date']
-        if vals.get('unit'):
-            context['uom'] = vals['unit']
-        with Transaction().set_context(context):
-            res['unit_price'] = product_obj.get_purchase_price(
-                    [vals['product']], vals.get('quantity') or 0
-                    )[vals['product']]
+        with Transaction().set_context(self._get_context_purchase_price()):
+            res['unit_price'] = Product.get_purchase_price([self.product],
+                self.quantity or 0)[self.product.id]
             if res['unit_price']:
                 res['unit_price'] = res['unit_price'].quantize(
-                    Decimal(1) / 10 ** self.unit_price.digits[1])
+                    Decimal(1) / 10 ** self.__class__.unit_price.digits[1])
         return res
 
-    def on_change_unit(self, vals):
-        return self.on_change_quantity(vals)
+    def on_change_unit(self):
+        return self.on_change_quantity()
 
-    def on_change_with_amount(self, vals):
-        currency_obj = Pool().get('currency.currency')
-        if vals.get('type') == 'line':
-            currency = vals.get('_parent_purchase.currency')
-            if currency and isinstance(currency, (int, long)):
-                currency = currency_obj.browse(
-                        vals['_parent_purchase.currency'])
-            amount = Decimal(str(vals.get('quantity') or '0.0')) * \
-                    (vals.get('unit_price') or Decimal('0.0'))
+    def on_change_with_amount(self):
+        if self.type == 'line':
+            currency = self.purchase.currency if self.purchase else None
+            amount = Decimal(str(self.quantity or '0.0')) * \
+                (self.unit_price or Decimal('0.0'))
             if currency:
-                return currency_obj.round(currency, amount)
+                return currency.round(amount)
             return amount
         return Decimal('0.0')
 
-    def get_amount(self, ids, name):
-        currency_obj = Pool().get('currency.currency')
-        res = {}
-        for line in self.browse(ids):
-            if line.type == 'line':
-                res[line.id] = currency_obj.round(line.purchase.currency,
-                        Decimal(str(line.quantity)) * line.unit_price)
-            elif line.type == 'subtotal':
-                res[line.id] = Decimal('0.0')
-                for line2 in line.purchase.lines:
-                    if line2.type == 'line':
-                        res[line.id] += currency_obj.round(
-                            line2.purchase.currency,
-                            Decimal(str(line2.quantity)) * line2.unit_price)
-                    elif line2.type == 'subtotal':
-                        if line.id == line2.id:
-                            break
-                        res[line.id] = Decimal('0.0')
-            else:
-                res[line.id] = Decimal('0.0')
-        return res
+    def get_amount(self, name):
+        if self.type == 'line':
+            return self.purchase.currency.round(
+                Decimal(str(self.quantity)) * self.unit_price)
+        elif self.type == 'subtotal':
+            amount = Decimal('0.0')
+            for line2 in self.purchase.lines:
+                if line2.type == 'line':
+                    amount += line2.purchase.currency.round(
+                        Decimal(str(line2.quantity)) * line2.unit_price)
+                elif line2.type == 'subtotal':
+                    if self == line2:
+                        break
+                    amount = Decimal('0.0')
+            return amount
+        return Decimal('0.0')
 
-    def get_from_location(self, ids, name):
-        result = {}
-        for line in self.browse(ids):
-            result[line.id] = line.purchase.party.supplier_location.id
-        return result
+    def get_from_location(self, name):
+        return self.purchase.party.supplier_location.id
 
-    def get_to_location(self, ids, name):
-        result = {}
-        for line in self.browse(ids):
-            if line.purchase.warehouse:
-                result[line.id] = line.purchase.warehouse.input_location.id
-            else:
-                result[line.id] = None
-        return result
+    def get_to_location(self, name):
+        if self.purchase.warehouse:
+            return self.purchase.warehouse.input_location.id
 
-    def _compute_delivery_date(self, product, party, date):
-        product_supplier_obj = Pool().get('purchase.product_supplier')
-        if product and product.product_suppliers:
-            for product_supplier in product.product_suppliers:
-                if product_supplier.party.id == party.id:
-                    return product_supplier_obj.compute_supply_date(
-                        product_supplier, date=date)
+    def on_change_with_delivery_date(self, name=None):
+        if (self.product
+                and self.purchase and self.purchase.party
+                and self.product.product_suppliers):
+            date = self.purchase.purchase_date if self.purchase else None
+            for product_supplier in self.product.product_suppliers:
+                if product_supplier.party == self.purchase.party:
+                    return product_supplier.compute_supply_date(date=date)
 
-    def on_change_with_delivery_date(self, values):
+    def get_invoice_line(self):
+        '''
+        Return a list of invoice line for purchase line
+        '''
         pool = Pool()
-        product_obj = pool.get('product.product')
-        party_obj = pool.get('party.party')
-        if values.get('product') and values.get('_parent_purchase.party'):
-            product = product_obj.browse(values['product'])
-            party = party_obj.browse(values['_parent_purchase.party'])
-            return self._compute_delivery_date(product, party,
-                values.get('_parent_purchase.purchase_date'))
+        Uom = pool.get('product.uom')
+        Property = pool.get('ir.property')
+        InvoiceLine = pool.get('account.invoice.line')
 
-    def get_delivery_date(self, ids, name):
-        dates = {}
-        for line in self.browse(ids):
-            dates[line.id] = self._compute_delivery_date(line.product,
-                line.purchase.party, line.purchase.purchase_date)
-        return dates
-
-    def get_invoice_line(self, line):
-        '''
-        Return invoice line values for purchase line
-
-        :param line: a BrowseRecord of the purchase line
-        :return: a list of invoice line values
-        '''
-        uom_obj = Pool().get('product.uom')
-        property_obj = Pool().get('ir.property')
-
-        res = {}
-        res['type'] = line.type
-        res['description'] = line.description
-        res['note'] = line.note
-        if line.type != 'line':
-            if (line.purchase.invoice_method == 'order'
-                    and (all(l.quantity >= 0 for l in line.sale.lines
+        with Transaction().set_user(0, set_context=True):
+            invoice_line = InvoiceLine()
+        invoice_line.type = self.type
+        invoice_line.description = self.description
+        invoice_line.note = self.note
+        if self.type != 'line':
+            if (self.purchase.invoice_method == 'order'
+                    and (all(l.quantity >= 0 for l in self.sale.lines
                             if l.type == 'line')
-                        or all(l.quantity <= 0 for l in line.sale.lines
+                        or all(l.quantity <= 0 for l in self.sale.lines
                             if l.type == 'line'))):
-                return [res]
+                return [invoice_line]
             else:
                 return []
-        if (line.purchase.invoice_method == 'order'
-                or not line.product
-                or line.product.type == 'service'):
-            quantity = line.quantity
+        if (self.purchase.invoice_method == 'order'
+                or not self.product
+                or self.product.type == 'service'):
+            quantity = self.quantity
         else:
             quantity = 0.0
-            for move in line.moves:
+            for move in self.moves:
                 if move.state == 'done':
-                    quantity += uom_obj.compute_qty(move.uom, move.quantity,
-                            line.unit)
+                    quantity += Uom.compute_qty(move.uom, move.quantity,
+                        self.unit)
 
-        skip_ids = set(l.id for i in line.purchase.invoices_recreated
+        skip_ids = set(l.id for i in self.purchase.invoices_recreated
             for l in i.lines)
-        for invoice_line in line.invoice_lines:
+        for invoice_line in self.invoice_lines:
             if invoice_line.type != 'line':
                 continue
             if invoice_line.id not in skip_ids:
-                quantity -= uom_obj.compute_qty(invoice_line.unit,
-                        invoice_line.quantity, line.unit)
-        res['quantity'] = quantity
+                quantity -= Uom.compute_qty(invoice_line.unit,
+                        invoice_line.quantity, self.unit)
+        invoice_line.quantity = quantity
 
-        if res['quantity'] <= 0.0:
+        if invoice_line.quantity <= 0.0:
             return []
-        res['unit'] = line.unit.id
-        res['product'] = line.product.id
-        res['unit_price'] = line.unit_price
-        res['taxes'] = [('set', [x.id for x in line.taxes])]
-        if line.product:
-            res['account'] = line.product.account_expense_used.id
-            if not res['account']:
+        invoice_line.unit = self.unit
+        invoice_line.product = self.product
+        invoice_line.unit_price = self.unit_price
+        invoice_line.taxes = self.taxes
+        if self.product:
+            invoice_line.account = self.product.account_expense_used
+            if not invoice_line.account:
                 self.raise_user_error('missing_account_expense',
-                        error_args=(line.product.rec_name,))
+                        error_args=(self.product.rec_name,))
         else:
             for model in ('product.template', 'product.category'):
-                res['account'] = property_obj.get('account_expense', model)
-                if res['account']:
+                invoice_line.account = Property.get('account_expense', model)
+                if invoice_line.account:
                     break
-            if not res['account']:
+            if not invoice_line.account:
                 self.raise_user_error('missing_account_expense_property')
-        return [res]
+        return [invoice_line]
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, lines, default=None):
         if default is None:
             default = {}
         default = default.copy()
@@ -1319,127 +1127,108 @@
         default['moves_ignored'] = None
         default['moves_recreated'] = None
         default['invoice_lines'] = None
-        return super(PurchaseLine, self).copy(ids, default=default)
+        return super(PurchaseLine, cls).copy(lines, default=default)
 
-    def get_move(self, line):
+    def get_move(self):
         '''
         Return move values for purchase line
         '''
         pool = Pool()
-        uom_obj = pool.get('product.uom')
+        Uom = pool.get('product.uom')
+        Move = pool.get('stock.move')
 
-        vals = {}
-        if line.type != 'line':
+        if self.type != 'line':
             return
-        if not line.product:
+        if not self.product:
             return
-        if line.product.type == 'service':
+        if self.product.type == 'service':
             return
-        skip_ids = set(x.id for x in line.moves_recreated)
-        quantity = line.quantity
-        for move in line.moves:
-            if move.id not in skip_ids:
-                quantity -= uom_obj.compute_qty(move.uom, move.quantity,
-                        line.unit)
+        skip = set(self.moves_recreated)
+        quantity = self.quantity
+        for move in self.moves:
+            if move not in skip:
+                quantity -= Uom.compute_qty(move.uom, move.quantity,
+                    self.unit)
         if quantity <= 0.0:
             return
-        if not line.purchase.party.supplier_location:
+        if not self.purchase.party.supplier_location:
             self.raise_user_error('supplier_location_required')
-        vals['quantity'] = quantity
-        vals['uom'] = line.unit.id
-        vals['product'] = line.product.id
-        vals['from_location'] = line.from_location.id
-        vals['to_location'] = line.to_location.id
-        vals['state'] = 'draft'
-        vals['company'] = line.purchase.company.id
-        vals['unit_price'] = line.unit_price
-        vals['currency'] = line.purchase.currency.id
-        vals['planned_date'] = line.delivery_date
-        return vals
+        with Transaction().set_user(0, set_context=True):
+            move = Move()
+        move.quantity = quantity
+        move.uom = self.unit
+        move.product = self.product
+        move.from_location = self.from_location
+        move.to_location = self.to_location
+        move.state = 'draft'
+        move.company = self.purchase.company
+        move.unit_price = self.unit_price
+        move.currency = self.purchase.currency
+        move.planned_date = self.delivery_date
+        return move
 
-    def create_move(self, line):
+    def create_move(self):
         '''
         Create move line
         '''
-        pool = Pool()
-        move_obj = pool.get('stock.move')
-
-        vals = self.get_move(line)
-        if not vals:
+        move = self.get_move()
+        if not move:
             return
+        move.save()
         with Transaction().set_user(0, set_context=True):
-            move_id = move_obj.create(vals)
-
-            self.write(line.id, {
-                'moves': [('add', move_id)],
-            })
-        return move_id
-
-PurchaseLine()
+            self.write([self], {
+                    'moves': [('add', [move.id])],
+                    })
+        return move
 
 
 class PurchaseLineTax(ModelSQL):
     'Purchase Line - Tax'
-    _name = 'purchase.line-account.tax'
+    __name__ = 'purchase.line-account.tax'
     _table = 'purchase_line_account_tax'
-    _description = __doc__
     line = fields.Many2One('purchase.line', 'Purchase Line',
             ondelete='CASCADE', select=True, required=True,
             domain=[('type', '=', 'line')])
     tax = fields.Many2One('account.tax', 'Tax', ondelete='RESTRICT',
             select=True, required=True, domain=[('parent', '=', None)])
 
-PurchaseLineTax()
-
 
 class PurchaseLineInvoiceLine(ModelSQL):
     'Purchase Line - Invoice Line'
-    _name = 'purchase.line-account.invoice.line'
+    __name__ = 'purchase.line-account.invoice.line'
     _table = 'purchase_line_invoice_lines_rel'
-    _description = __doc__
     purchase_line = fields.Many2One('purchase.line', 'Purchase Line',
             ondelete='CASCADE', select=True, required=True)
     invoice_line = fields.Many2One('account.invoice.line', 'Invoice Line',
             ondelete='RESTRICT', select=True, required=True)
 
-PurchaseLineInvoiceLine()
-
 
 class PurchaseLineIgnoredMove(ModelSQL):
     'Purchase Line - Ignored Move'
-    _name = 'purchase.line-ignored-stock.move'
+    __name__ = 'purchase.line-ignored-stock.move'
     _table = 'purchase_line_moves_ignored_rel'
-    _description = __doc__
     purchase_line = fields.Many2One('purchase.line', 'Purchase Line',
             ondelete='CASCADE', select=True, required=True)
     move = fields.Many2One('stock.move', 'Move', ondelete='RESTRICT',
             select=True, required=True)
 
-PurchaseLineIgnoredMove()
-
 
 class PurchaseLineRecreatedMove(ModelSQL):
     'Purchase Line - Ignored Move'
-    _name = 'purchase.line-recreated-stock.move'
+    __name__ = 'purchase.line-recreated-stock.move'
     _table = 'purchase_line_moves_recreated_rel'
-    _description = __doc__
     purchase_line = fields.Many2One('purchase.line', 'Purchase Line',
             ondelete='CASCADE', select=True, required=True)
     move = fields.Many2One('stock.move', 'Move', ondelete='RESTRICT',
             select=True, required=True)
 
-PurchaseLineRecreatedMove()
-
 
 class PurchaseReport(CompanyReport):
-    _name = 'purchase.purchase'
+    __name__ = 'purchase.purchase'
 
-PurchaseReport()
 
-
-class Template(ModelSQL, ModelView):
-    _name = "product.template"
-
+class Template:
+    __name__ = "product.template"
     purchasable = fields.Boolean('Purchasable', states={
             'readonly': ~Eval('active', True),
             }, depends=['active'])
@@ -1458,54 +1247,41 @@
         on_change_with=['default_uom', 'purchase_uom', 'purchasable'],
         depends=['active', 'purchasable', 'default_uom_category'])
 
-    def __init__(self):
-        super(Template, self).__init__()
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(Template, cls).__setup__()
+        cls._error_messages.update({
                 'change_purchase_uom': 'Purchase prices are based ' \
                     'on the purchase uom, are you sure to change it?',
             })
-        self.account_expense = copy.copy(self.account_expense)
-        self.account_expense.states = copy.copy(self.account_expense.states)
         required = ~Eval('account_category') & Eval('purchasable', False)
-        if not self.account_expense.states.get('required'):
-            self.account_expense.states['required'] = required
+        if not cls.account_expense.states.get('required'):
+            cls.account_expense.states['required'] = required
         else:
-            self.account_expense.states['required'] = (
-                self.account_expense.states['required'] | required)
-        if 'account_category' not in self.account_expense.depends:
-            self.account_expense = copy.copy(self.account_expense)
-            self.account_expense.depends = \
-                    copy.copy(self.account_expense.depends)
-            self.account_expense.depends.append('account_category')
-        if 'purchasable' not in self.account_expense.depends:
-            self.account_expense = copy.copy(self.account_expense)
-            self.account_expense.depends = \
-                    copy.copy(self.account_expense.depends)
-            self.account_expense.depends.append('purchasable')
-        self._reset_columns()
+            cls.account_expense.states['required'] = (
+                cls.account_expense.states['required'] | required)
+        if 'account_category' not in cls.account_expense.depends:
+            cls.account_expense.depends.append('account_category')
+        if 'purchasable' not in cls.account_expense.depends:
+            cls.account_expense.depends.append('purchasable')
 
-    def default_purchasable(self):
+    @staticmethod
+    def default_purchasable():
         return Transaction().context.get('purchasable') or False
 
-    def on_change_with_purchase_uom(self, vals):
-        uom_obj = Pool().get('product.uom')
-        res = None
+    def on_change_with_purchase_uom(self):
+        if self.default_uom:
+            if self.purchase_uom:
+                if self.default_uom.category == self.purchase_uom.category:
+                    return self.purchase_uom.id
+                else:
+                    return self.default_uom.id
+            else:
+                return self.default_uom.id
 
-        if vals.get('default_uom'):
-            default_uom = uom_obj.browse(vals['default_uom'])
-            if vals.get('purchase_uom'):
-                purchase_uom = uom_obj.browse(vals['purchase_uom'])
-                if default_uom.category.id == purchase_uom.category.id:
-                    res = purchase_uom.id
-                else:
-                    res = default_uom.id
-            else:
-                res = default_uom.id
-        return res
-
-    def write(self, ids, vals):
+    @classmethod
+    def write(cls, templates, vals):
         if vals.get("purchase_uom"):
-            templates = self.browse(ids)
             for template in templates:
                 if not template.purchase_uom:
                     continue
